using System;
using System.Collections;
using System.Collections.Generic;

namespace Smdn.Formats.Ini {
  public class Section : IEnumerable<KeyValuePair<string, string>> {
    public string this[string entry] {
      get
      {
        if (entries.ContainsKey(entry))
          return entries[entry];
        else
          return null;
      }
      set
      {
        if (entries.ContainsKey(entry))
          entries[entry] = value;
        else
          entries.Add(entry, value);
      }
    }

    public string Name { get; set; }

    public Dictionary<string, string> Entries {
      get { return entries; }
    }

    internal Section(string name)
    {
      Name = name;
      entries = new Dictionary<string, string>();
    }

    IEnumerator IEnumerable.GetEnumerator()
    {
      return GetEnumerator();
    }

    public IEnumerator<KeyValuePair<string, string>> GetEnumerator()
    {
      return entries.GetEnumerator();
    }

    public override string ToString ()
    {
      return string.Format("{{Name={0}, Entries={1}}}", Name, entries.Count);
    }

    private Dictionary<string, string> entries;
  }
}