using System;

namespace Smdn.Protocols.Imap4.Protocol {
  // ResponseTypes:
  //   ImapProtocolResponse(abstract base)
  //     => handles '7. Server Responses'
  //     ImapStatusResponse
  //       => handles '7.1. Server Responses - Status Responses'
  //     ImapDataResponse
  //       => handles '7.2. Server Responses - Server and Mailbox Status'
  //                  '7.3. Server Responses - Mailbox Size'
  //                  '7.4. Server Responses - Message Status'
  //     ImapCommandContinuationRequest
  //       => handles '7.5. Server Responses - Command Continuation Request'

  public class ImapDataResponse : ImapProtocolResponse {
    public ImapData[] Data {
      get { return data; }
    }

    public ImapDataResponse(ImapData[] data, string response)
      : base(response)
    {
      if (data == null)
        throw new ArgumentNullException("data");

      this.data = data;
    }

    public override string ToString()
    {
      return string.Format("{{Data={0}}}", data.Length);
    }

    private ImapData[] data = null;
  }
}