using System;

namespace Smdn.Protocols.Pop3 {
  public class PopServerInfo {
    public PopUri Uri {
      get { return uri; }
    }

    /// <value>timestamp in server banner greeting</value>
    public string Timestamp {
      get { return timestamp; }
      internal set { timestamp = value; }
    }

    public PopCapability Capabilities {
      get { return capabilities; }
      internal set { capabilities = value; }
    }

    internal PopServerInfo(PopUri uri)
    {
      this.uri = uri;
    }

    public override string ToString()
    {
      return string.Format("{{Uri={0}, Capabilities={1}}}",
                           uri,
                           capabilities);
    }

    private PopUri uri;
    private string timestamp = null;
    private PopCapability capabilities = new PopCapability();
  }
}
