using System;

using Smdn.Protocols.Pop3.Protocol;

namespace Smdn.Protocols.Pop3.Transaction.Transactions {
  internal class RsetTransaction : TransactionBase {

    // ProcessRset
    //   ->WaitForRset
    // WaitForRset
    //   x Conclude

    public RsetTransaction(PopConnection connection, PopRequest request)
      : base(connection, request)
    {
    }

    protected override ProcessTransactionDelegate Reset()
    {
      return ProcessRset;
    }

    private void ProcessRset()
    {
      Send("RSET");

      Transit(WaitForRset);
    }

    private void WaitForRset()
    {
      PopProtocolResponse response;

      if (!Receive(out response))
        return;

      if (response is PopStatusResponse) {
        var status = response as PopStatusResponse;

        if (status.Status == PopProtocolStatus.Positive) {
          Conclude(new PopResponse(PopTransactionStatus.Ok, "resetted"));
        }
        else {
          ConcludeError(status);
        }
      }
    }
  }
}
